import rospy

from typing import Optional

from {{ skillset }}_managers.srv import State, Transition

{% for res in resources %}
class {{ res.name|data_name }}Resource:
    def __init__(self, **kwargs):
        self.__name = '{{ res.name }}'
        self.__transition_client = rospy.ServiceProxy('resource/change_{}'.format('{{ res.name }}'), Transition)
        self.__state_client = rospy.ServiceProxy('resource/get_{}'.format('{{ res.name }}'), State)

    def print_state(self):
        rospy.loginfo(f"resource {self.name} in state {self.get()}")

    @property
    def name(self) -> str:
        return self.__name

    def ready(self):
        return self.wait_manager(timeout=0.1)

    def wait_manager(self, timeout: Optional[float] = None) -> bool:
        try:
            rospy.logdebug(f"Resource {self.__name} wait for manager server")
            self.__transition_client.wait_for_service(timeout=timeout)
            self.__state_client.wait_for_service(timeout=timeout)
            return True
        except rospy.ROSException:
            return False

    def __nonzero__(self):
        return self.ready()

    def get(self):
        try:
            rospy.logdebug(f"get resource state {self.__name}")
            result = self.__state_client()
        except rospy.ServiceException:
            return None
        rospy.logdebug(f"-- state: {result.state}")
        return result.state

    def __eq__(self, state):
        return state == self.get()

    def to(self, state):
        try:
            result = self.__transition_client(state)
        except rospy.ServiceException:
            return False
        return result.success

    def __call__(self, tgt = None):
        if tgt is None:
            return self.get()
        else:
            return self.to(tgt)
{% endfor %}
